Index: trunk/MagicSoft/Mars/mgeom/MGeomCam.h
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCam.h	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCam.h	(revision 2521)
@@ -35,4 +35,12 @@
     void CalcNumSectors();
     void InitOuterRing();
+    void InitGeometry()
+    {
+        CalcNumSectors();
+        CalcMaxRadius();
+        CalcPixRatio();
+        InitOuterRing();
+    }
+
 
 public:
@@ -60,3 +68,2 @@
 
 #endif
-
Index: trunk/MagicSoft/Mars/mgeom/MGeomCamCT1.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCamCT1.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCamCT1.cc	(revision 2521)
@@ -56,7 +56,5 @@
     CreateCam();
     CreateNN();
-    CalcNumSectors();
-    CalcMaxRadius();
-    CalcPixRatio();
+    InitGeometry();
 } 
 
@@ -200,6 +198,4 @@
       (*this)[i].SetNeighbors(nn[i][0], nn[i][1], nn[i][2],
                               nn[i][3], nn[i][4], nn[i][5]);
-
-  InitOuterRing();
 }
 
Index: trunk/MagicSoft/Mars/mgeom/MGeomCamCT1Daniel.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCamCT1Daniel.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCamCT1Daniel.cc	(revision 2521)
@@ -60,7 +60,5 @@
     CreateCam();
     CreateNN();
-    CalcNumSectors();
-    CalcMaxRadius();
-    CalcPixRatio();
+    InitGeometry();
 } 
 
@@ -204,6 +202,4 @@
       (*this)[i].SetNeighbors(nn[i][0], nn[i][1], nn[i][2],
                               nn[i][3], nn[i][4], nn[i][5]);
-
-  InitOuterRing();
 }
 
Index: trunk/MagicSoft/Mars/mgeom/MGeomCamECO1000.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCamECO1000.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCamECO1000.cc	(revision 2521)
@@ -52,7 +52,5 @@
     CreateCam();
     CreateNN();
-    CalcNumSectors();
-    CalcMaxRadius();
-    CalcPixRatio();
+    InitGeometry();
 }
 
@@ -895,5 +893,3 @@
       (*this)[i].SetNeighbors(nn[i][0], nn[i][1], nn[i][2],
                               nn[i][3], nn[i][4], nn[i][5]);
-
-  InitOuterRing();
 }
Index: trunk/MagicSoft/Mars/mgeom/MGeomCamECO1000HG.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCamECO1000HG.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCamECO1000HG.cc	(revision 2521)
@@ -56,7 +56,5 @@
     CreateCam();
     CreateNN();
-    CalcNumSectors();
-    CalcMaxRadius();
-    CalcPixRatio();
+    InitGeometry();
 }
 
@@ -3403,10 +3401,8 @@
     {  2285,  2286,  2398,  2400,  -1,  -1},
     {  2286,  2399,  -1,  -1,  -1,  -1} // 2400
-    };
+  };
 
   for (Int_t i=0; i<2401; i++)
       (*this)[i].SetNeighbors(nn[i][0], nn[i][1], nn[i][2],
                               nn[i][3], nn[i][4], nn[i][5]);
-
-  InitOuterRing();
 }
Index: trunk/MagicSoft/Mars/mgeom/MGeomCamMagic.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCamMagic.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCamMagic.cc	(revision 2521)
@@ -48,8 +48,5 @@
     CreateCam();
     CreateNN();
-    CalcPixRatio();
-    CalcNumSectors();
-    CalcMaxRadius();
-    CalcPixRatio();
+    InitGeometry();
 }
 
@@ -925,5 +922,3 @@
         (*this)[i].SetNeighbors(nn[i][0], nn[i][1], nn[i][2],
                                 nn[i][3], nn[i][4], nn[i][5]);
-
-    InitOuterRing();
 }
Index: trunk/MagicSoft/Mars/mgeom/MGeomCamMagic919.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCamMagic919.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCamMagic919.cc	(revision 2521)
@@ -49,6 +49,5 @@
     CreateCam();
     CreateNN();
-    CalcMaxRadius();
-    CalcPixRatio();
+    InitGeometry();
 }
 
@@ -1362,5 +1361,3 @@
       (*this)[i].SetNeighbors(nn[i][0], nn[i][1], nn[i][2],
                               nn[i][3], nn[i][4], nn[i][5]);
-
-  InitOuterRing();
 }
Index: trunk/MagicSoft/Mars/mgeom/MGeomCamMagicHG.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCamMagicHG.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCamMagicHG.cc	(revision 2521)
@@ -48,7 +48,5 @@
     CreateCam();
     CreateNN();
-    CalcNumSectors();
-    CalcMaxRadius();
-    CalcPixRatio();
+    InitGeometry();
 }
 
@@ -3397,5 +3395,3 @@
         (*this)[i].SetNeighbors(nn[i][0], nn[i][1], nn[i][2],
                                 nn[i][3], nn[i][4], nn[i][5]);
-
-    InitOuterRing();
 }
Index: trunk/MagicSoft/Mars/mgeom/MGeomCorsikaCT.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomCorsikaCT.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomCorsikaCT.cc	(revision 2521)
@@ -64,4 +64,3 @@
   fCTdiam=ctdiam;
   fCTfocal=ctfocal;
-
 }
Index: trunk/MagicSoft/Mars/mgeom/MGeomMirror.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomMirror.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomMirror.cc	(revision 2521)
@@ -103,5 +103,6 @@
 }
 
-void MGeomMirror::SetMirrorDeviations(Float_t dev_x, Float_t dev_y){
+void MGeomMirror::SetMirrorDeviations(Float_t dev_x, Float_t dev_y)
+{
     fDeviationX=dev_x;  // deviation in x [cm]
     fDeviationY=dev_y;  // deviation in y [cm]
@@ -127,10 +128,2 @@
     fReflectivity = ref;
 }
-
-
-
-
-
-
-
-
Index: trunk/MagicSoft/Mars/mgeom/MGeomPMT.cc
===================================================================
--- trunk/MagicSoft/Mars/mgeom/MGeomPMT.cc	(revision 2470)
+++ trunk/MagicSoft/Mars/mgeom/MGeomPMT.cc	(revision 2521)
@@ -69,7 +69,2 @@
     fQE = qe;
 }
-
-
-
-
-