Index: trunk/MagicSoft/Mars/Changelog
===================================================================
--- trunk/MagicSoft/Mars/Changelog	(revision 2528)
+++ trunk/MagicSoft/Mars/Changelog	(revision 2529)
@@ -3,4 +3,46 @@
 
                                                  -*-*- END OF LINE -*-*-
+ 2003/11/18: Thomas Bretz
+
+   * mars.cc:
+     - changed Usage to standard Usage
+     
+   * merpp.cc, mona.cc, readraw.cc, star.cc, status.cc,
+     mbase/MArgs.[h,cc]:
+     - removed const-qualifier for argv
+     
+   * mbase/MTask.cc:
+     - fixed a bug in PrintStatistics (setfill was not set)
+     
+   * mbase/MTaskList.cc:
+     - simplified PrintStatistics
+   
+   * mbase/MTime.h:
+     - added Getter
+     
+   * mfileio/MReadTree.cc:
+     - remove a leading "*" when checking whether a branch which 
+       should be enabled exists
+       
+   * mfileio/MWriteRootFile.cc:
+     - fixed a crash when Print is called and GetTree() returns NULL
+     
+   * mhist/MHEvent.cc:
+     - implemented more levels (MeV, GeV, etc) for energy display
+     
+   * mraw/MRawSocketRead.cc:
+     - removed some obsolete comment
+     
+   * mreport/MReport.[h,cc]:
+     - added FindTime
+     - removed an invalid line (ReadAngle) in the header file
+     - Set class version to 1
+     - do not write fTime '//!'
+     
+   * mreport/MReportFileRead.cc:
+     - fixed handling of MTimes
+
+
+
  2003/11/18: Abelardo Moralejo
 
@@ -8,48 +50,56 @@
      - Fixed missing initialization of fLongitmax
 
+
+
  2003/11/18: Markus Gaug
 
    * manalysis/MCalibrationCalc: 
-	- performs the eventloop and fills the calibration classes
+     - performs the eventloop and fills the calibration classes
 
    * manalysis/MCalibrationCam: 
-	- holds the classes: MCalibrationPix and MCalibrationBlindPix and MCalibrationPINDiode
-	- one MCalibrationPix per pixel
+     - holds the classes: MCalibrationPix and MCalibrationBlindPix
+       and MCalibrationPINDiode
+     - one MCalibrationPix per pixel
 
    * manalysis/MCalibrationPix:
-	- holds the fit results and conversion factors, etc per pixel
-	- hold histograms MHCalibrationPixel
+     - holds the fit results and conversion factors, etc per pixel
+     - hold histograms MHCalibrationPixel
 
    * manalysis/MCalibrationBlindPix:
-	- holds fit results and derived number of photons, etc
-	- hold histogram MHCalibrationBlindPixel
+     - holds fit results and derived number of photons, etc
+     - hold histogram MHCalibrationBlindPixel
 
    * manalysis/MCalibrationPINDiode:
-	- holds fit results and derived number of photons, etc
-	- hold histogram MHCalibrationPINDiode
+     - holds fit results and derived number of photons, etc
+     - hold histogram MHCalibrationPINDiode
 
    * mhist/MHCalibrationPix:
-	- histograms with sum of charges, time slices and reduced charges vs. event number
-	- fit functions
+     - histograms with sum of charges, time slices and reduced
+       charges vs. event number
+     - fit functions
 
    * mhist/MHCalibrationPixel:
-	- histograms with sum of charges, time slices and reduced charges vs. event number
-	- fit functions
+     - histograms with sum of charges, time slices and reduced
+       charges vs. event number
+     - fit functions
 
    * mhist/MHCalibrationBlindPixel:
-	- histograms with sum of charges, time slices and reduced charges vs. event number
-	- fit functions
+     - histograms with sum of charges, time slices and reduced
+       charges vs. event number
+     - fit functions
 
    * mhist/MHCalibrationPINDiode:
-	- histograms with sum of charges, time slices and reduced charges vs. event number
-	- fit functions
-
-   *mhist/MH:
-	- new function: CutEdges
-
-   *macros/calibration.C
-	- simple macro showing the functionning
-
- 
+     - histograms with sum of charges, time slices and reduced
+       charges vs. event number
+     - fit functions
+
+   * mhist/MH:
+     - new function: CutEdges
+
+   * macros/calibration.C
+     - simple macro showing the functionning
+
+
+
  2003/11/17: Thomas Bretz
  