Index: trunk/MagicSoft/Mars/mreport/MReportCC.cc
===================================================================
--- trunk/MagicSoft/Mars/mreport/MReportCC.cc	(revision 2687)
+++ trunk/MagicSoft/Mars/mreport/MReportCC.cc	(revision 2687)
@@ -0,0 +1,78 @@
+/* ======================================================================== *\
+!
+! *
+! * This file is part of MARS, the MAGIC Analysis and Reconstruction
+! * Software. It is distributed to you in the hope that it can be a useful
+! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
+! * It is distributed WITHOUT ANY WARRANTY.
+! *
+! * Permission to use, copy, modify and distribute this software and its
+! * documentation for any purpose is hereby granted without fee,
+! * provided that the above copyright notice appear in all copies and
+! * that both that copyright notice and this permission notice appear
+! * in supporting documentation. It is provided "as is" without express
+! * or implied warranty.
+! *
+!
+!
+!   Author(s): Thomas Bretz, 12/2003 <mailto:tbretz@astro.uni-wuerzburg.de>
+!
+!   Copyright: MAGIC Software Development, 2000-2003
+!
+!
+\* ======================================================================== */
+
+//////////////////////////////////////////////////////////////////////////////
+//
+//  MReportCC
+//
+// This is the class interpreting and storing the CC-REPORT information.
+//
+// From here maily weather station data is decoded such as
+// temperature, humidity, wind-speed and solar radiation
+//
+//////////////////////////////////////////////////////////////////////////////
+#include "MReportCC.h"
+
+#include "MLogManip.h"
+
+#include "MAstro.h"
+
+ClassImp(MReportCC);
+
+using namespace std;
+
+MReportCC::MReportCC() : MReport("CC-REPORT")
+{
+    fName  = "MReportCC";
+    fTitle = "Class for CC-REPORT information";
+}
+
+Bool_t MReportCC::InterpreteBody(TString &str)
+{
+    // Remove the 30 tokens of the subsystem status
+    //  table 12.1 p59
+    for (int i=0; i<30; i++)
+        str.Remove(0, str.First(' ')+1);
+
+    Int_t len;
+    Float_t zd, az, dec, ra;
+    const Int_t n=sscanf(str.Data(),
+                         "%*f %*f %*f %*f %f %f %f %f %*f %*f %n",
+                         &fTemperature, &fSolarRadiation, &fWindSpeed,
+                         &fHumidity, &len);
+    if (n!=4)
+    {
+        *fLog << err << "ERROR - Wrong number of arguments." << endl;
+        return kFALSE;
+    }
+    str.Remove(0, len);
+
+    if (str!=(TString)"OVER")
+    {
+        *fLog << err << "ERROR - Termination (OVER) too far away." << endl;
+        return kFALSE;
+    }
+
+    return kTRUE;
+}
Index: trunk/MagicSoft/Mars/mreport/MReportCC.h
===================================================================
--- trunk/MagicSoft/Mars/mreport/MReportCC.h	(revision 2687)
+++ trunk/MagicSoft/Mars/mreport/MReportCC.h	(revision 2687)
@@ -0,0 +1,24 @@
+#ifndef MARS_MReportCC
+#define MARS_MReportCC
+
+#ifndef MARS_MReport
+#include "MReport.h"
+#endif
+
+class MReportCC : public MReport
+{
+private:
+    Float_t fHumidity;       // [%]
+    Float_t fTemperature;    // [deg] celsius
+    Float_t fWindSpeed;      // [km/h]
+    Float_t fSolarRadiation; // [W/m^2] IR-Radiation
+
+public:
+    MReportCC();
+
+    Bool_t InterpreteBody(TString &str);
+
+    ClassDef(MReportCC, 1) // Class for CC-REPORT information
+};
+
+#endif
Index: trunk/MagicSoft/Mars/mreport/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mreport/Makefile	(revision 2678)
+++ trunk/MagicSoft/Mars/mreport/Makefile	(revision 2687)
@@ -30,4 +30,5 @@
 
 SRCFILES = MReport.cc \
+           MReportCC.cc \
            MReportDAQ.cc \
            MReportDrive.cc \
Index: trunk/MagicSoft/Mars/mreport/ReportLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mreport/ReportLinkDef.h	(revision 2678)
+++ trunk/MagicSoft/Mars/mreport/ReportLinkDef.h	(revision 2687)
@@ -7,4 +7,5 @@
 #pragma link C++ class MReport+;
 
+#pragma link C++ class MReportCC+;
 #pragma link C++ class MReportDAQ+;
 #pragma link C++ class MReportDrive+;